ZoneOffsetTransitionRule.TimeDefinition (Java SE 26 & JDK 26)
Description: declaration: module: java.base, package: java.time.zone, class: ZoneOffsetTransitionRule, enum: TimeDefinition
Keywords: java.time.zone.ZoneOffsetTransitionRule.TimeDefinition class

# Enum Class ZoneOffsetTransitionRule.TimeDefinition

java.lang.Object
java.lang.Enum<ZoneOffsetTransitionRule.TimeDefinition>
java.time.zone.ZoneOffsetTransitionRule.TimeDefinition

All Implemented Interfaces:
  `Serializable, Comparable<ZoneOffsetTransitionRule.TimeDefinition>, Constable`

Enclosing class:
  `ZoneOffsetTransitionRule`

public static enum ZoneOffsetTransitionRule.TimeDefinition extends Enum<ZoneOffsetTransitionRule.TimeDefinition>
A definition of the way a local time can be converted to the actual transition date-time.

Time zone rules are expressed in one of three ways:

- Relative to UTC
- Relative to the standard offset in force
- Relative to the wall offset (what you would see on a clock on the wall)

Since:
  1.8

- ## Nested Class Summary

  ### Nested classes/interfaces declared in class Enum

  `Enum.EnumDesc<E>`
  Modifier and Type
  Class
  Description
  `static final class`
  `Enum.EnumDesc<E extends Enum<E>>`
  A nominal descriptor for an `enum` constant.

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `STANDARD`
  The local date-time is expressed in terms of the standard offset.
  `UTC`
  The local date-time is expressed in terms of the UTC offset.
  `WALL`
  The local date-time is expressed in terms of the wall offset.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `LocalDateTime`
  `createDateTime(LocalDateTime dateTime, ZoneOffset standardOffset, ZoneOffset wallOffset)`
  Converts the specified local date-time to the local date-time actually seen on a wall clock.
  `static ZoneOffsetTransitionRule.TimeDefinition`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static ZoneOffsetTransitionRule.TimeDefinition[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods declared in class Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`
  Modifier and Type
  Method
  Description
  `protected final Object`
  `clone()`
  Throws CloneNotSupportedException.
  `final int`
  `compareTo(ZoneOffsetTransitionRule.TimeDefinition o)`
  Compares this enum with the specified object for order.
  `final Optional<Enum.EnumDesc<ZoneOffsetTransitionRule.TimeDefinition>>`
  `describeConstable()`
  Returns an enum descriptor `EnumDesc` for this instance, if one can be constructed, or an empty `Optional` if one cannot be.
  `final boolean`
  `equals(Object other)`
  Returns true if the specified object is equal to this enum constant.
  `protected final void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization has been deprecated for removal.
  `final Class<ZoneOffsetTransitionRule.TimeDefinition>`
  `getDeclaringClass()`
  Returns the Class object corresponding to this enum constant's enum type.
  `final int`
  `hashCode()`
  Returns a hash code for this enum constant.
  `final String`
  `name()`
  Returns the name of this enum constant, exactly as declared in its enum declaration.
  `final int`
  `ordinal()`
  Returns the ordinal of this enumeration constant (its position in its enum declaration, where the initial constant is assigned an ordinal of zero).
  `String`
  `toString()`
  Returns the name of this enum constant, as contained in the declaration.
  `static <T extends Enum<T>>
  T`
  `valueOf(Class<T> enumClass, String name)`
  Returns the enum constant of the specified enum class with the specified name.

  ### Methods declared in class Object

  `getClass, notify, notifyAll, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Enum Constant Details

  - ### UTC

    public static final ZoneOffsetTransitionRule.TimeDefinition UTC
    The local date-time is expressed in terms of the UTC offset.

  - ### WALL

    public static final ZoneOffsetTransitionRule.TimeDefinition WALL
    The local date-time is expressed in terms of the wall offset.

  - ### STANDARD

    public static final ZoneOffsetTransitionRule.TimeDefinition STANDARD
    The local date-time is expressed in terms of the standard offset.

- ## Method Details

  - ### values

    public static ZoneOffsetTransitionRule.TimeDefinition[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static ZoneOffsetTransitionRule.TimeDefinition valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null

  - ### createDateTime

    public LocalDateTime createDateTime(LocalDateTime dateTime, ZoneOffset standardOffset, ZoneOffset wallOffset)
    Converts the specified local date-time to the local date-time actually seen on a wall clock.

    This method converts using the type of this enum. The output is defined relative to the 'before' offset of the transition.

    The UTC type uses the UTC offset. The STANDARD type uses the standard offset. The WALL type returns the input date-time. The result is intended for use with the wall-offset.

    Parameters:
      `dateTime` - the local date-time, not null
      `standardOffset` - the standard offset, not null
      `wallOffset` - the wall offset, not null
    Returns:
      the date-time relative to the wall/before offset, not null